<?php

namespace Shop\Models\PricelistSheet\Base;

use \DateTime;
use \Exception;
use \PDO;
use MoySklad\Models\MoySkladTask\MoySkladTask;
use MoySklad\Models\MoySkladTask\MoySkladTaskQuery;
use MoySklad\Models\MoySkladTask\Base\MoySkladTask as BaseMoySkladTask;
use MoySklad\Models\MoySkladTask\Map\MoySkladTaskTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveRecord\ActiveRecordInterface;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\BadMethodCallException;
use Propel\Runtime\Exception\LogicException;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Parser\AbstractParser;
use Propel\Runtime\Util\PropelDateTime;
use Shop\Models\Currency\Currency;
use Shop\Models\Currency\CurrencyQuery;
use Shop\Models\Position\Position;
use Shop\Models\Position\PositionQuery;
use Shop\Models\Position\Base\Position as BasePosition;
use Shop\Models\Position\Map\PositionTableMap;
use Shop\Models\PricelistFile\PricelistFile;
use Shop\Models\PricelistFile\PricelistFileQuery;
use Shop\Models\PricelistSheet\PricelistSheet as ChildPricelistSheet;
use Shop\Models\PricelistSheet\PricelistSheetQuery as ChildPricelistSheetQuery;
use Shop\Models\PricelistSheet\Map\PricelistSheetTableMap;

/**
 * Base class that represents a row from the 'shop_pricelist_sheets' table.
 *
 *
 *
 * @package    propel.generator.Models.PricelistSheet.Base
 */
abstract class PricelistSheet implements ActiveRecordInterface
{
    /**
     * TableMap class name
     */
    const TABLE_MAP = '\\Shop\\Models\\PricelistSheet\\Map\\PricelistSheetTableMap';


    /**
     * attribute to determine if this object has previously been saved.
     * @var boolean
     */
    protected $new = true;

    /**
     * attribute to determine whether this object has been deleted.
     * @var boolean
     */
    protected $deleted = false;

    /**
     * The columns that have been modified in current object.
     * Tracking modified columns allows us to only update modified columns.
     * @var array
     */
    protected $modifiedColumns = array();

    /**
     * The (virtual) columns that are added at runtime
     * The formatters can add supplementary columns based on a resultset
     * @var array
     */
    protected $virtualColumns = array();

    /**
     * The value for the id field.
     *
     * @var        int
     */
    protected $id;

    /**
     * The value for the title field.
     *
     * @var        string
     */
    protected $title;

    /**
     * The value for the date_update field.
     *
     * @var        DateTime
     */
    protected $date_update;

    /**
     * The value for the pricelist_file_id field.
     *
     * @var        int
     */
    protected $pricelist_file_id;

    /**
     * The value for the crrency_id field.
     *
     * @var        int
     */
    protected $crrency_id;

    /**
     * @var        PricelistFile
     */
    protected $aPricelistFile;

    /**
     * @var        Currency
     */
    protected $aCurrency;

    /**
     * @var        ObjectCollection|MoySkladTask[] Collection to store aggregation of MoySkladTask objects.
     */
    protected $collMoySkladTasks;
    protected $collMoySkladTasksPartial;

    /**
     * @var        ObjectCollection|Position[] Collection to store aggregation of Position objects.
     */
    protected $collPositions;
    protected $collPositionsPartial;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     *
     * @var boolean
     */
    protected $alreadyInSave = false;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|MoySkladTask[]
     */
    protected $moySkladTasksScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|Position[]
     */
    protected $positionsScheduledForDeletion = null;

    /**
     * Initializes internal state of Shop\Models\PricelistSheet\Base\PricelistSheet object.
     */
    public function __construct()
    {
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return boolean True if the object has been modified.
     */
    public function isModified()
    {
        return !!$this->modifiedColumns;
    }

    /**
     * Has specified column been modified?
     *
     * @param  string  $col column fully qualified name (TableMap::TYPE_COLNAME), e.g. Book::AUTHOR_ID
     * @return boolean True if $col has been modified.
     */
    public function isColumnModified($col)
    {
        return $this->modifiedColumns && isset($this->modifiedColumns[$col]);
    }

    /**
     * Get the columns that have been modified in this object.
     * @return array A unique list of the modified column names for this object.
     */
    public function getModifiedColumns()
    {
        return $this->modifiedColumns ? array_keys($this->modifiedColumns) : [];
    }

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return boolean true, if the object has never been persisted.
     */
    public function isNew()
    {
        return $this->new;
    }

    /**
     * Setter for the isNew attribute.  This method will be called
     * by Propel-generated children and objects.
     *
     * @param boolean $b the state of the object.
     */
    public function setNew($b)
    {
        $this->new = (boolean) $b;
    }

    /**
     * Whether this object has been deleted.
     * @return boolean The deleted state of this object.
     */
    public function isDeleted()
    {
        return $this->deleted;
    }

    /**
     * Specify whether this object has been deleted.
     * @param  boolean $b The deleted state of this object.
     * @return void
     */
    public function setDeleted($b)
    {
        $this->deleted = (boolean) $b;
    }

    /**
     * Sets the modified state for the object to be false.
     * @param  string $col If supplied, only the specified column is reset.
     * @return void
     */
    public function resetModified($col = null)
    {
        if (null !== $col) {
            if (isset($this->modifiedColumns[$col])) {
                unset($this->modifiedColumns[$col]);
            }
        } else {
            $this->modifiedColumns = array();
        }
    }

    /**
     * Compares this with another <code>PricelistSheet</code> instance.  If
     * <code>obj</code> is an instance of <code>PricelistSheet</code>, delegates to
     * <code>equals(PricelistSheet)</code>.  Otherwise, returns <code>false</code>.
     *
     * @param  mixed   $obj The object to compare to.
     * @return boolean Whether equal to the object specified.
     */
    public function equals($obj)
    {
        if (!$obj instanceof static) {
            return false;
        }

        if ($this === $obj) {
            return true;
        }

        if (null === $this->getPrimaryKey() || null === $obj->getPrimaryKey()) {
            return false;
        }

        return $this->getPrimaryKey() === $obj->getPrimaryKey();
    }

    /**
     * Get the associative array of the virtual columns in this object
     *
     * @return array
     */
    public function getVirtualColumns()
    {
        return $this->virtualColumns;
    }

    /**
     * Checks the existence of a virtual column in this object
     *
     * @param  string  $name The virtual column name
     * @return boolean
     */
    public function hasVirtualColumn($name)
    {
        return array_key_exists($name, $this->virtualColumns);
    }

    /**
     * Get the value of a virtual column in this object
     *
     * @param  string $name The virtual column name
     * @return mixed
     *
     * @throws PropelException
     */
    public function getVirtualColumn($name)
    {
        if (!$this->hasVirtualColumn($name)) {
            throw new PropelException(sprintf('Cannot get value of inexistent virtual column %s.', $name));
        }

        return $this->virtualColumns[$name];
    }

    /**
     * Set the value of a virtual column in this object
     *
     * @param string $name  The virtual column name
     * @param mixed  $value The value to give to the virtual column
     *
     * @return $this|PricelistSheet The current object, for fluid interface
     */
    public function setVirtualColumn($name, $value)
    {
        $this->virtualColumns[$name] = $value;

        return $this;
    }

    /**
     * Logs a message using Propel::log().
     *
     * @param  string  $msg
     * @param  int     $priority One of the Propel::LOG_* logging levels
     * @return boolean
     */
    protected function log($msg, $priority = Propel::LOG_INFO)
    {
        return Propel::log(get_class($this) . ': ' . $msg, $priority);
    }

    /**
     * Export the current object properties to a string, using a given parser format
     * <code>
     * $book = BookQuery::create()->findPk(9012);
     * echo $book->exportTo('JSON');
     *  => {"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * @param  mixed   $parser                 A AbstractParser instance, or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param  boolean $includeLazyLoadColumns (optional) Whether to include lazy load(ed) columns. Defaults to TRUE.
     * @return string  The exported data
     */
    public function exportTo($parser, $includeLazyLoadColumns = true)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        return $parser->fromArray($this->toArray(TableMap::TYPE_PHPNAME, $includeLazyLoadColumns, array(), true));
    }

    /**
     * Clean up internal collections prior to serializing
     * Avoids recursive loops that turn into segmentation faults when serializing
     */
    public function __sleep()
    {
        $this->clearAllReferences();

        $cls = new \ReflectionClass($this);
        $propertyNames = [];
        $serializableProperties = array_diff($cls->getProperties(), $cls->getProperties(\ReflectionProperty::IS_STATIC));

        foreach($serializableProperties as $property) {
            $propertyNames[] = $property->getName();
        }

        return $propertyNames;
    }

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Get the [title] column value.
     *
     * @return string
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * Get the [optionally formatted] temporal [date_update] column value.
     *
     *
     * @param      string|null $format The date/time format string (either date()-style or strftime()-style).
     *                            If format is NULL, then the raw DateTime object will be returned.
     *
     * @return string|DateTime Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
     *
     * @throws PropelException - if unable to parse/validate the date/time value.
     */
    public function getDateUpdate($format = NULL)
    {
        if ($format === null) {
            return $this->date_update;
        } else {
            return $this->date_update instanceof \DateTimeInterface ? $this->date_update->format($format) : null;
        }
    }

    /**
     * Get the [pricelist_file_id] column value.
     *
     * @return int
     */
    public function getPricelistFileId()
    {
        return $this->pricelist_file_id;
    }

    /**
     * Get the [crrency_id] column value.
     *
     * @return int
     */
    public function getCurrencyId()
    {
        return $this->crrency_id;
    }

    /**
     * Set the value of [id] column.
     *
     * @param int $v new value
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[PricelistSheetTableMap::COL_ID] = true;
        }

        return $this;
    } // setId()

    /**
     * Set the value of [title] column.
     *
     * @param string $v new value
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet The current object (for fluent API support)
     */
    public function setTitle($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->title !== $v) {
            $this->title = $v;
            $this->modifiedColumns[PricelistSheetTableMap::COL_TITLE] = true;
        }

        return $this;
    } // setTitle()

    /**
     * Sets the value of [date_update] column to a normalized version of the date/time value specified.
     *
     * @param  mixed $v string, integer (timestamp), or \DateTimeInterface value.
     *               Empty strings are treated as NULL.
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet The current object (for fluent API support)
     */
    public function setDateUpdate($v)
    {
        $dt = PropelDateTime::newInstance($v, null, 'DateTime');
        if ($this->date_update !== null || $dt !== null) {
            if ($this->date_update === null || $dt === null || $dt->format("Y-m-d H:i:s.u") !== $this->date_update->format("Y-m-d H:i:s.u")) {
                $this->date_update = $dt === null ? null : clone $dt;
                $this->modifiedColumns[PricelistSheetTableMap::COL_DATE_UPDATE] = true;
            }
        } // if either are not null

        return $this;
    } // setDateUpdate()

    /**
     * Set the value of [pricelist_file_id] column.
     *
     * @param int $v new value
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet The current object (for fluent API support)
     */
    public function setPricelistFileId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->pricelist_file_id !== $v) {
            $this->pricelist_file_id = $v;
            $this->modifiedColumns[PricelistSheetTableMap::COL_PRICELIST_FILE_ID] = true;
        }

        if ($this->aPricelistFile !== null && $this->aPricelistFile->getId() !== $v) {
            $this->aPricelistFile = null;
        }

        return $this;
    } // setPricelistFileId()

    /**
     * Set the value of [crrency_id] column.
     *
     * @param int $v new value
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet The current object (for fluent API support)
     */
    public function setCurrencyId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->crrency_id !== $v) {
            $this->crrency_id = $v;
            $this->modifiedColumns[PricelistSheetTableMap::COL_CRRENCY_ID] = true;
        }

        if ($this->aCurrency !== null && $this->aCurrency->getId() !== $v) {
            $this->aCurrency = null;
        }

        return $this;
    } // setCurrencyId()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
        // otherwise, everything was equal, so return TRUE
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array   $row       The row returned by DataFetcher->fetch().
     * @param int     $startcol  0-based offset column which indicates which restultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @param string  $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                  One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                            TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false, $indexType = TableMap::TYPE_NUM)
    {
        try {

            $col = $row[TableMap::TYPE_NUM == $indexType ? 0 + $startcol : PricelistSheetTableMap::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)];
            $this->id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 1 + $startcol : PricelistSheetTableMap::translateFieldName('Title', TableMap::TYPE_PHPNAME, $indexType)];
            $this->title = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 2 + $startcol : PricelistSheetTableMap::translateFieldName('DateUpdate', TableMap::TYPE_PHPNAME, $indexType)];
            if ($col === '0000-00-00 00:00:00') {
                $col = null;
            }
            $this->date_update = (null !== $col) ? PropelDateTime::newInstance($col, null, 'DateTime') : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 3 + $startcol : PricelistSheetTableMap::translateFieldName('PricelistFileId', TableMap::TYPE_PHPNAME, $indexType)];
            $this->pricelist_file_id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 4 + $startcol : PricelistSheetTableMap::translateFieldName('CurrencyId', TableMap::TYPE_PHPNAME, $indexType)];
            $this->crrency_id = (null !== $col) ? (int) $col : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }

            return $startcol + 5; // 5 = PricelistSheetTableMap::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException(sprintf('Error populating %s object', '\\Shop\\Models\\PricelistSheet\\PricelistSheet'), 0, $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {
        if ($this->aPricelistFile !== null && $this->pricelist_file_id !== $this->aPricelistFile->getId()) {
            $this->aPricelistFile = null;
        }
        if ($this->aCurrency !== null && $this->crrency_id !== $this->aCurrency->getId()) {
            $this->aCurrency = null;
        }
    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param      boolean $deep (optional) Whether to also de-associated any related objects.
     * @param      ConnectionInterface $con (optional) The ConnectionInterface connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(PricelistSheetTableMap::DATABASE_NAME);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $dataFetcher = ChildPricelistSheetQuery::create(null, $this->buildPkeyCriteria())->setFormatter(ModelCriteria::FORMAT_STATEMENT)->find($con);
        $row = $dataFetcher->fetch();
        $dataFetcher->close();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true, $dataFetcher->getIndexType()); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->aPricelistFile = null;
            $this->aCurrency = null;
            $this->collMoySkladTasks = null;

            $this->collPositions = null;

        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param      ConnectionInterface $con
     * @return void
     * @throws PropelException
     * @see PricelistSheet::setDeleted()
     * @see PricelistSheet::isDeleted()
     */
    public function delete(ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(PricelistSheetTableMap::DATABASE_NAME);
        }

        $con->transaction(function () use ($con) {
            $deleteQuery = ChildPricelistSheetQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $this->setDeleted(true);
            }
        });
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param      ConnectionInterface $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see doSave()
     */
    public function save(ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($this->alreadyInSave) {
            return 0;
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(PricelistSheetTableMap::DATABASE_NAME);
        }

        return $con->transaction(function () use ($con) {
            $ret = $this->preSave($con);
            $isInsert = $this->isNew();
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                PricelistSheetTableMap::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }

            return $affectedRows;
        });
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param      ConnectionInterface $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see save()
     */
    protected function doSave(ConnectionInterface $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aPricelistFile !== null) {
                if ($this->aPricelistFile->isModified() || $this->aPricelistFile->isNew()) {
                    $affectedRows += $this->aPricelistFile->save($con);
                }
                $this->setPricelistFile($this->aPricelistFile);
            }

            if ($this->aCurrency !== null) {
                if ($this->aCurrency->isModified() || $this->aCurrency->isNew()) {
                    $affectedRows += $this->aCurrency->save($con);
                }
                $this->setCurrency($this->aCurrency);
            }

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                    $affectedRows += 1;
                } else {
                    $affectedRows += $this->doUpdate($con);
                }
                $this->resetModified();
            }

            if ($this->moySkladTasksScheduledForDeletion !== null) {
                if (!$this->moySkladTasksScheduledForDeletion->isEmpty()) {
                    foreach ($this->moySkladTasksScheduledForDeletion as $moySkladTask) {
                        // need to save related object because we set the relation to null
                        $moySkladTask->save($con);
                    }
                    $this->moySkladTasksScheduledForDeletion = null;
                }
            }

            if ($this->collMoySkladTasks !== null) {
                foreach ($this->collMoySkladTasks as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->positionsScheduledForDeletion !== null) {
                if (!$this->positionsScheduledForDeletion->isEmpty()) {
                    \Shop\Models\Position\PositionQuery::create()
                        ->filterByPrimaryKeys($this->positionsScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->positionsScheduledForDeletion = null;
                }
            }

            if ($this->collPositions !== null) {
                foreach ($this->collPositions as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param      ConnectionInterface $con
     *
     * @throws PropelException
     * @see doSave()
     */
    protected function doInsert(ConnectionInterface $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[PricelistSheetTableMap::COL_ID] = true;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . PricelistSheetTableMap::COL_ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(PricelistSheetTableMap::COL_ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(PricelistSheetTableMap::COL_TITLE)) {
            $modifiedColumns[':p' . $index++]  = '`title`';
        }
        if ($this->isColumnModified(PricelistSheetTableMap::COL_DATE_UPDATE)) {
            $modifiedColumns[':p' . $index++]  = '`date_update`';
        }
        if ($this->isColumnModified(PricelistSheetTableMap::COL_PRICELIST_FILE_ID)) {
            $modifiedColumns[':p' . $index++]  = '`pricelist_file_id`';
        }
        if ($this->isColumnModified(PricelistSheetTableMap::COL_CRRENCY_ID)) {
            $modifiedColumns[':p' . $index++]  = '`crrency_id`';
        }

        $sql = sprintf(
            'INSERT INTO `shop_pricelist_sheets` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`title`':
                        $stmt->bindValue($identifier, $this->title, PDO::PARAM_STR);
                        break;
                    case '`date_update`':
                        $stmt->bindValue($identifier, $this->date_update ? $this->date_update->format("Y-m-d H:i:s.u") : null, PDO::PARAM_STR);
                        break;
                    case '`pricelist_file_id`':
                        $stmt->bindValue($identifier, $this->pricelist_file_id, PDO::PARAM_INT);
                        break;
                    case '`crrency_id`':
                        $stmt->bindValue($identifier, $this->crrency_id, PDO::PARAM_INT);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), 0, $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', 0, $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param      ConnectionInterface $con
     *
     * @return Integer Number of updated rows
     * @see doSave()
     */
    protected function doUpdate(ConnectionInterface $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();

        return $selectCriteria->doUpdate($valuesCriteria, $con);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param      string $name name
     * @param      string $type The type of fieldname the $name is of:
     *                     one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                     TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                     Defaults to TableMap::TYPE_PHPNAME.
     * @return mixed Value of field.
     */
    public function getByName($name, $type = TableMap::TYPE_PHPNAME)
    {
        $pos = PricelistSheetTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param      int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getTitle();
                break;
            case 2:
                return $this->getDateUpdate();
                break;
            case 3:
                return $this->getPricelistFileId();
                break;
            case 4:
                return $this->getCurrencyId();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     *                    TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                    Defaults to TableMap::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to TRUE.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = TableMap::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {

        if (isset($alreadyDumpedObjects['PricelistSheet'][$this->hashCode()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['PricelistSheet'][$this->hashCode()] = true;
        $keys = PricelistSheetTableMap::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getTitle(),
            $keys[2] => $this->getDateUpdate(),
            $keys[3] => $this->getPricelistFileId(),
            $keys[4] => $this->getCurrencyId(),
        );
        if ($result[$keys[2]] instanceof \DateTimeInterface) {
            $result[$keys[2]] = $result[$keys[2]]->format('c');
        }

        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->aPricelistFile) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'pricelistFile';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'shop_pricelist_files';
                        break;
                    default:
                        $key = 'PricelistFile';
                }

                $result[$key] = $this->aPricelistFile->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
            if (null !== $this->aCurrency) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'currency';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'shop_currencies';
                        break;
                    default:
                        $key = 'Currency';
                }

                $result[$key] = $this->aCurrency->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
            if (null !== $this->collMoySkladTasks) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'moySkladTasks';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'moysklad_taskss';
                        break;
                    default:
                        $key = 'MoySkladTasks';
                }

                $result[$key] = $this->collMoySkladTasks->toArray(null, false, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collPositions) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'positions';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'shop_positionss';
                        break;
                    default:
                        $key = 'Positions';
                }

                $result[$key] = $this->collPositions->toArray(null, false, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param  string $name
     * @param  mixed  $value field value
     * @param  string $type The type of fieldname the $name is of:
     *                one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                Defaults to TableMap::TYPE_PHPNAME.
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet
     */
    public function setByName($name, $value, $type = TableMap::TYPE_PHPNAME)
    {
        $pos = PricelistSheetTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);

        return $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param  int $pos position in xml schema
     * @param  mixed $value field value
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setTitle($value);
                break;
            case 2:
                $this->setDateUpdate($value);
                break;
            case 3:
                $this->setPricelistFileId($value);
                break;
            case 4:
                $this->setCurrencyId($value);
                break;
        } // switch()

        return $this;
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param      array  $arr     An array to populate the object from.
     * @param      string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = TableMap::TYPE_PHPNAME)
    {
        $keys = PricelistSheetTableMap::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) {
            $this->setId($arr[$keys[0]]);
        }
        if (array_key_exists($keys[1], $arr)) {
            $this->setTitle($arr[$keys[1]]);
        }
        if (array_key_exists($keys[2], $arr)) {
            $this->setDateUpdate($arr[$keys[2]]);
        }
        if (array_key_exists($keys[3], $arr)) {
            $this->setPricelistFileId($arr[$keys[3]]);
        }
        if (array_key_exists($keys[4], $arr)) {
            $this->setCurrencyId($arr[$keys[4]]);
        }
    }

     /**
     * Populate the current object from a string, using a given parser format
     * <code>
     * $book = new Book();
     * $book->importFrom('JSON', '{"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param mixed $parser A AbstractParser instance,
     *                       or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param string $data The source data to import from
     * @param string $keyType The type of keys the array uses.
     *
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet The current object, for fluid interface
     */
    public function importFrom($parser, $data, $keyType = TableMap::TYPE_PHPNAME)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        $this->fromArray($parser->toArray($data), $keyType);

        return $this;
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(PricelistSheetTableMap::DATABASE_NAME);

        if ($this->isColumnModified(PricelistSheetTableMap::COL_ID)) {
            $criteria->add(PricelistSheetTableMap::COL_ID, $this->id);
        }
        if ($this->isColumnModified(PricelistSheetTableMap::COL_TITLE)) {
            $criteria->add(PricelistSheetTableMap::COL_TITLE, $this->title);
        }
        if ($this->isColumnModified(PricelistSheetTableMap::COL_DATE_UPDATE)) {
            $criteria->add(PricelistSheetTableMap::COL_DATE_UPDATE, $this->date_update);
        }
        if ($this->isColumnModified(PricelistSheetTableMap::COL_PRICELIST_FILE_ID)) {
            $criteria->add(PricelistSheetTableMap::COL_PRICELIST_FILE_ID, $this->pricelist_file_id);
        }
        if ($this->isColumnModified(PricelistSheetTableMap::COL_CRRENCY_ID)) {
            $criteria->add(PricelistSheetTableMap::COL_CRRENCY_ID, $this->crrency_id);
        }

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @throws LogicException if no primary key is defined
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = ChildPricelistSheetQuery::create();
        $criteria->add(PricelistSheetTableMap::COL_ID, $this->id);

        return $criteria;
    }

    /**
     * If the primary key is not null, return the hashcode of the
     * primary key. Otherwise, return the hash code of the object.
     *
     * @return int Hashcode
     */
    public function hashCode()
    {
        $validPk = null !== $this->getId();

        $validPrimaryKeyFKs = 0;
        $primaryKeyFKs = [];

        if ($validPk) {
            return crc32(json_encode($this->getPrimaryKey(), JSON_UNESCAPED_UNICODE));
        } elseif ($validPrimaryKeyFKs) {
            return crc32(json_encode($primaryKeyFKs, JSON_UNESCAPED_UNICODE));
        }

        return spl_object_hash($this);
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param       int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {
        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param      object $copyObj An object of \Shop\Models\PricelistSheet\PricelistSheet (or compatible) type.
     * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param      boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setTitle($this->getTitle());
        $copyObj->setDateUpdate($this->getDateUpdate());
        $copyObj->setPricelistFileId($this->getPricelistFileId());
        $copyObj->setCurrencyId($this->getCurrencyId());

        if ($deepCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);

            foreach ($this->getMoySkladTasks() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addMoySkladTask($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getPositions() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addPosition($relObj->copy($deepCopy));
                }
            }

        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param  boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return \Shop\Models\PricelistSheet\PricelistSheet Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Declares an association between this object and a PricelistFile object.
     *
     * @param  PricelistFile $v
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet The current object (for fluent API support)
     * @throws PropelException
     */
    public function setPricelistFile(PricelistFile $v = null)
    {
        if ($v === null) {
            $this->setPricelistFileId(NULL);
        } else {
            $this->setPricelistFileId($v->getId());
        }

        $this->aPricelistFile = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the PricelistFile object, it will not be re-added.
        if ($v !== null) {
            $v->addPricelistSheet($this);
        }


        return $this;
    }


    /**
     * Get the associated PricelistFile object
     *
     * @param  ConnectionInterface $con Optional Connection object.
     * @return PricelistFile The associated PricelistFile object.
     * @throws PropelException
     */
    public function getPricelistFile(ConnectionInterface $con = null)
    {
        if ($this->aPricelistFile === null && ($this->pricelist_file_id != 0)) {
            $this->aPricelistFile = PricelistFileQuery::create()->findPk($this->pricelist_file_id, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aPricelistFile->addPricelistSheets($this);
             */
        }

        return $this->aPricelistFile;
    }

    /**
     * Declares an association between this object and a Currency object.
     *
     * @param  Currency $v
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet The current object (for fluent API support)
     * @throws PropelException
     */
    public function setCurrency(Currency $v = null)
    {
        if ($v === null) {
            $this->setCurrencyId(NULL);
        } else {
            $this->setCurrencyId($v->getId());
        }

        $this->aCurrency = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the Currency object, it will not be re-added.
        if ($v !== null) {
            $v->addPricelistSheet($this);
        }


        return $this;
    }


    /**
     * Get the associated Currency object
     *
     * @param  ConnectionInterface $con Optional Connection object.
     * @return Currency The associated Currency object.
     * @throws PropelException
     */
    public function getCurrency(ConnectionInterface $con = null)
    {
        if ($this->aCurrency === null && ($this->crrency_id != 0)) {
            $this->aCurrency = CurrencyQuery::create()->findPk($this->crrency_id, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aCurrency->addPricelistSheets($this);
             */
        }

        return $this->aCurrency;
    }


    /**
     * Initializes a collection based on the name of a relation.
     * Avoids crafting an 'init[$relationName]s' method name
     * that wouldn't work when StandardEnglishPluralizer is used.
     *
     * @param      string $relationName The name of the relation to initialize
     * @return void
     */
    public function initRelation($relationName)
    {
        if ('MoySkladTask' == $relationName) {
            $this->initMoySkladTasks();
            return;
        }
        if ('Position' == $relationName) {
            $this->initPositions();
            return;
        }
    }

    /**
     * Clears out the collMoySkladTasks collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return void
     * @see        addMoySkladTasks()
     */
    public function clearMoySkladTasks()
    {
        $this->collMoySkladTasks = null; // important to set this to NULL since that means it is uninitialized
    }

    /**
     * Reset is the collMoySkladTasks collection loaded partially.
     */
    public function resetPartialMoySkladTasks($v = true)
    {
        $this->collMoySkladTasksPartial = $v;
    }

    /**
     * Initializes the collMoySkladTasks collection.
     *
     * By default this just sets the collMoySkladTasks collection to an empty array (like clearcollMoySkladTasks());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param      boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initMoySkladTasks($overrideExisting = true)
    {
        if (null !== $this->collMoySkladTasks && !$overrideExisting) {
            return;
        }

        $collectionClassName = MoySkladTaskTableMap::getTableMap()->getCollectionClassName();

        $this->collMoySkladTasks = new $collectionClassName;
        $this->collMoySkladTasks->setModel('\MoySklad\Models\MoySkladTask\MoySkladTask');
    }

    /**
     * Gets an array of MoySkladTask objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildPricelistSheet is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param      Criteria $criteria optional Criteria object to narrow the query
     * @param      ConnectionInterface $con optional connection object
     * @return ObjectCollection|MoySkladTask[] List of MoySkladTask objects
     * @throws PropelException
     */
    public function getMoySkladTasks(Criteria $criteria = null, ConnectionInterface $con = null)
    {
        $partial = $this->collMoySkladTasksPartial && !$this->isNew();
        if (null === $this->collMoySkladTasks || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collMoySkladTasks) {
                // return empty collection
                $this->initMoySkladTasks();
            } else {
                $collMoySkladTasks = MoySkladTaskQuery::create(null, $criteria)
                    ->filterByPricelistSheet($this)
                    ->find($con);

                if (null !== $criteria) {
                    if (false !== $this->collMoySkladTasksPartial && count($collMoySkladTasks)) {
                        $this->initMoySkladTasks(false);

                        foreach ($collMoySkladTasks as $obj) {
                            if (false == $this->collMoySkladTasks->contains($obj)) {
                                $this->collMoySkladTasks->append($obj);
                            }
                        }

                        $this->collMoySkladTasksPartial = true;
                    }

                    return $collMoySkladTasks;
                }

                if ($partial && $this->collMoySkladTasks) {
                    foreach ($this->collMoySkladTasks as $obj) {
                        if ($obj->isNew()) {
                            $collMoySkladTasks[] = $obj;
                        }
                    }
                }

                $this->collMoySkladTasks = $collMoySkladTasks;
                $this->collMoySkladTasksPartial = false;
            }
        }

        return $this->collMoySkladTasks;
    }

    /**
     * Sets a collection of MoySkladTask objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param      Collection $moySkladTasks A Propel collection.
     * @param      ConnectionInterface $con Optional connection object
     * @return $this|ChildPricelistSheet The current object (for fluent API support)
     */
    public function setMoySkladTasks(Collection $moySkladTasks, ConnectionInterface $con = null)
    {
        /** @var MoySkladTask[] $moySkladTasksToDelete */
        $moySkladTasksToDelete = $this->getMoySkladTasks(new Criteria(), $con)->diff($moySkladTasks);


        $this->moySkladTasksScheduledForDeletion = $moySkladTasksToDelete;

        foreach ($moySkladTasksToDelete as $moySkladTaskRemoved) {
            $moySkladTaskRemoved->setPricelistSheet(null);
        }

        $this->collMoySkladTasks = null;
        foreach ($moySkladTasks as $moySkladTask) {
            $this->addMoySkladTask($moySkladTask);
        }

        $this->collMoySkladTasks = $moySkladTasks;
        $this->collMoySkladTasksPartial = false;

        return $this;
    }

    /**
     * Returns the number of related BaseMoySkladTask objects.
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct
     * @param      ConnectionInterface $con
     * @return int             Count of related BaseMoySkladTask objects.
     * @throws PropelException
     */
    public function countMoySkladTasks(Criteria $criteria = null, $distinct = false, ConnectionInterface $con = null)
    {
        $partial = $this->collMoySkladTasksPartial && !$this->isNew();
        if (null === $this->collMoySkladTasks || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collMoySkladTasks) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getMoySkladTasks());
            }

            $query = MoySkladTaskQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByPricelistSheet($this)
                ->count($con);
        }

        return count($this->collMoySkladTasks);
    }

    /**
     * Method called to associate a MoySkladTask object to this object
     * through the MoySkladTask foreign key attribute.
     *
     * @param  MoySkladTask $l MoySkladTask
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet The current object (for fluent API support)
     */
    public function addMoySkladTask(MoySkladTask $l)
    {
        if ($this->collMoySkladTasks === null) {
            $this->initMoySkladTasks();
            $this->collMoySkladTasksPartial = true;
        }

        if (!$this->collMoySkladTasks->contains($l)) {
            $this->doAddMoySkladTask($l);

            if ($this->moySkladTasksScheduledForDeletion and $this->moySkladTasksScheduledForDeletion->contains($l)) {
                $this->moySkladTasksScheduledForDeletion->remove($this->moySkladTasksScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param MoySkladTask $moySkladTask The MoySkladTask object to add.
     */
    protected function doAddMoySkladTask(MoySkladTask $moySkladTask)
    {
        $this->collMoySkladTasks[]= $moySkladTask;
        $moySkladTask->setPricelistSheet($this);
    }

    /**
     * @param  MoySkladTask $moySkladTask The MoySkladTask object to remove.
     * @return $this|ChildPricelistSheet The current object (for fluent API support)
     */
    public function removeMoySkladTask(MoySkladTask $moySkladTask)
    {
        if ($this->getMoySkladTasks()->contains($moySkladTask)) {
            $pos = $this->collMoySkladTasks->search($moySkladTask);
            $this->collMoySkladTasks->remove($pos);
            if (null === $this->moySkladTasksScheduledForDeletion) {
                $this->moySkladTasksScheduledForDeletion = clone $this->collMoySkladTasks;
                $this->moySkladTasksScheduledForDeletion->clear();
            }
            $this->moySkladTasksScheduledForDeletion[]= $moySkladTask;
            $moySkladTask->setPricelistSheet(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this PricelistSheet is new, it will return
     * an empty collection; or if this PricelistSheet has previously
     * been saved, it will retrieve related MoySkladTasks from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in PricelistSheet.
     *
     * @param      Criteria $criteria optional Criteria object to narrow the query
     * @param      ConnectionInterface $con optional connection object
     * @param      string $joinBehavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return ObjectCollection|MoySkladTask[] List of MoySkladTask objects
     */
    public function getMoySkladTasksJoinShopBrand(Criteria $criteria = null, ConnectionInterface $con = null, $joinBehavior = Criteria::LEFT_JOIN)
    {
        $query = MoySkladTaskQuery::create(null, $criteria);
        $query->joinWith('ShopBrand', $joinBehavior);

        return $this->getMoySkladTasks($query, $con);
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this PricelistSheet is new, it will return
     * an empty collection; or if this PricelistSheet has previously
     * been saved, it will retrieve related MoySkladTasks from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in PricelistSheet.
     *
     * @param      Criteria $criteria optional Criteria object to narrow the query
     * @param      ConnectionInterface $con optional connection object
     * @param      string $joinBehavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return ObjectCollection|MoySkladTask[] List of MoySkladTask objects
     */
    public function getMoySkladTasksJoinCategory(Criteria $criteria = null, ConnectionInterface $con = null, $joinBehavior = Criteria::LEFT_JOIN)
    {
        $query = MoySkladTaskQuery::create(null, $criteria);
        $query->joinWith('Category', $joinBehavior);

        return $this->getMoySkladTasks($query, $con);
    }

    /**
     * Clears out the collPositions collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return void
     * @see        addPositions()
     */
    public function clearPositions()
    {
        $this->collPositions = null; // important to set this to NULL since that means it is uninitialized
    }

    /**
     * Reset is the collPositions collection loaded partially.
     */
    public function resetPartialPositions($v = true)
    {
        $this->collPositionsPartial = $v;
    }

    /**
     * Initializes the collPositions collection.
     *
     * By default this just sets the collPositions collection to an empty array (like clearcollPositions());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param      boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initPositions($overrideExisting = true)
    {
        if (null !== $this->collPositions && !$overrideExisting) {
            return;
        }

        $collectionClassName = PositionTableMap::getTableMap()->getCollectionClassName();

        $this->collPositions = new $collectionClassName;
        $this->collPositions->setModel('\Shop\Models\Position\Position');
    }

    /**
     * Gets an array of Position objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildPricelistSheet is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param      Criteria $criteria optional Criteria object to narrow the query
     * @param      ConnectionInterface $con optional connection object
     * @return ObjectCollection|Position[] List of Position objects
     * @throws PropelException
     */
    public function getPositions(Criteria $criteria = null, ConnectionInterface $con = null)
    {
        $partial = $this->collPositionsPartial && !$this->isNew();
        if (null === $this->collPositions || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collPositions) {
                // return empty collection
                $this->initPositions();
            } else {
                $collPositions = PositionQuery::create(null, $criteria)
                    ->filterByPricelistSheet($this)
                    ->find($con);

                if (null !== $criteria) {
                    if (false !== $this->collPositionsPartial && count($collPositions)) {
                        $this->initPositions(false);

                        foreach ($collPositions as $obj) {
                            if (false == $this->collPositions->contains($obj)) {
                                $this->collPositions->append($obj);
                            }
                        }

                        $this->collPositionsPartial = true;
                    }

                    return $collPositions;
                }

                if ($partial && $this->collPositions) {
                    foreach ($this->collPositions as $obj) {
                        if ($obj->isNew()) {
                            $collPositions[] = $obj;
                        }
                    }
                }

                $this->collPositions = $collPositions;
                $this->collPositionsPartial = false;
            }
        }

        return $this->collPositions;
    }

    /**
     * Sets a collection of Position objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param      Collection $positions A Propel collection.
     * @param      ConnectionInterface $con Optional connection object
     * @return $this|ChildPricelistSheet The current object (for fluent API support)
     */
    public function setPositions(Collection $positions, ConnectionInterface $con = null)
    {
        /** @var Position[] $positionsToDelete */
        $positionsToDelete = $this->getPositions(new Criteria(), $con)->diff($positions);


        $this->positionsScheduledForDeletion = $positionsToDelete;

        foreach ($positionsToDelete as $positionRemoved) {
            $positionRemoved->setPricelistSheet(null);
        }

        $this->collPositions = null;
        foreach ($positions as $position) {
            $this->addPosition($position);
        }

        $this->collPositions = $positions;
        $this->collPositionsPartial = false;

        return $this;
    }

    /**
     * Returns the number of related BasePosition objects.
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct
     * @param      ConnectionInterface $con
     * @return int             Count of related BasePosition objects.
     * @throws PropelException
     */
    public function countPositions(Criteria $criteria = null, $distinct = false, ConnectionInterface $con = null)
    {
        $partial = $this->collPositionsPartial && !$this->isNew();
        if (null === $this->collPositions || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collPositions) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getPositions());
            }

            $query = PositionQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByPricelistSheet($this)
                ->count($con);
        }

        return count($this->collPositions);
    }

    /**
     * Method called to associate a Position object to this object
     * through the Position foreign key attribute.
     *
     * @param  Position $l Position
     * @return $this|\Shop\Models\PricelistSheet\PricelistSheet The current object (for fluent API support)
     */
    public function addPosition(Position $l)
    {
        if ($this->collPositions === null) {
            $this->initPositions();
            $this->collPositionsPartial = true;
        }

        if (!$this->collPositions->contains($l)) {
            $this->doAddPosition($l);

            if ($this->positionsScheduledForDeletion and $this->positionsScheduledForDeletion->contains($l)) {
                $this->positionsScheduledForDeletion->remove($this->positionsScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param Position $position The Position object to add.
     */
    protected function doAddPosition(Position $position)
    {
        $this->collPositions[]= $position;
        $position->setPricelistSheet($this);
    }

    /**
     * @param  Position $position The Position object to remove.
     * @return $this|ChildPricelistSheet The current object (for fluent API support)
     */
    public function removePosition(Position $position)
    {
        if ($this->getPositions()->contains($position)) {
            $pos = $this->collPositions->search($position);
            $this->collPositions->remove($pos);
            if (null === $this->positionsScheduledForDeletion) {
                $this->positionsScheduledForDeletion = clone $this->collPositions;
                $this->positionsScheduledForDeletion->clear();
            }
            $this->positionsScheduledForDeletion[]= clone $position;
            $position->setPricelistSheet(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this PricelistSheet is new, it will return
     * an empty collection; or if this PricelistSheet has previously
     * been saved, it will retrieve related Positions from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in PricelistSheet.
     *
     * @param      Criteria $criteria optional Criteria object to narrow the query
     * @param      ConnectionInterface $con optional connection object
     * @param      string $joinBehavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return ObjectCollection|Position[] List of Position objects
     */
    public function getPositionsJoinSale(Criteria $criteria = null, ConnectionInterface $con = null, $joinBehavior = Criteria::LEFT_JOIN)
    {
        $query = PositionQuery::create(null, $criteria);
        $query->joinWith('Sale', $joinBehavior);

        return $this->getPositions($query, $con);
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this PricelistSheet is new, it will return
     * an empty collection; or if this PricelistSheet has previously
     * been saved, it will retrieve related Positions from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in PricelistSheet.
     *
     * @param      Criteria $criteria optional Criteria object to narrow the query
     * @param      ConnectionInterface $con optional connection object
     * @param      string $joinBehavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return ObjectCollection|Position[] List of Position objects
     */
    public function getPositionsJoinProduct(Criteria $criteria = null, ConnectionInterface $con = null, $joinBehavior = Criteria::LEFT_JOIN)
    {
        $query = PositionQuery::create(null, $criteria);
        $query->joinWith('Product', $joinBehavior);

        return $this->getPositions($query, $con);
    }

    /**
     * Clears the current object, sets all attributes to their default values and removes
     * outgoing references as well as back-references (from other objects to this one. Results probably in a database
     * change of those foreign objects when you call `save` there).
     */
    public function clear()
    {
        if (null !== $this->aPricelistFile) {
            $this->aPricelistFile->removePricelistSheet($this);
        }
        if (null !== $this->aCurrency) {
            $this->aCurrency->removePricelistSheet($this);
        }
        $this->id = null;
        $this->title = null;
        $this->date_update = null;
        $this->pricelist_file_id = null;
        $this->crrency_id = null;
        $this->alreadyInSave = false;
        $this->clearAllReferences();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references and back-references to other model objects or collections of model objects.
     *
     * This method is used to reset all php object references (not the actual reference in the database).
     * Necessary for object serialisation.
     *
     * @param      boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep) {
            if ($this->collMoySkladTasks) {
                foreach ($this->collMoySkladTasks as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collPositions) {
                foreach ($this->collPositions as $o) {
                    $o->clearAllReferences($deep);
                }
            }
        } // if ($deep)

        $this->collMoySkladTasks = null;
        $this->collPositions = null;
        $this->aPricelistFile = null;
        $this->aCurrency = null;
    }

    /**
     * Return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(PricelistSheetTableMap::DEFAULT_STRING_FORMAT);
    }

    /**
     * Code to be run before persisting the object
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preSave(ConnectionInterface $con = null)
    {
                return true;
    }

    /**
     * Code to be run after persisting the object
     * @param ConnectionInterface $con
     */
    public function postSave(ConnectionInterface $con = null)
    {
            }

    /**
     * Code to be run before inserting to database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preInsert(ConnectionInterface $con = null)
    {
                return true;
    }

    /**
     * Code to be run after inserting to database
     * @param ConnectionInterface $con
     */
    public function postInsert(ConnectionInterface $con = null)
    {
            }

    /**
     * Code to be run before updating the object in database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preUpdate(ConnectionInterface $con = null)
    {
                return true;
    }

    /**
     * Code to be run after updating the object in database
     * @param ConnectionInterface $con
     */
    public function postUpdate(ConnectionInterface $con = null)
    {
            }

    /**
     * Code to be run before deleting the object in database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preDelete(ConnectionInterface $con = null)
    {
                return true;
    }

    /**
     * Code to be run after deleting the object in database
     * @param ConnectionInterface $con
     */
    public function postDelete(ConnectionInterface $con = null)
    {
            }


    /**
     * Derived method to catches calls to undefined methods.
     *
     * Provides magic import/export method support (fromXML()/toXML(), fromYAML()/toYAML(), etc.).
     * Allows to define default __call() behavior if you overwrite __call()
     *
     * @param string $name
     * @param mixed  $params
     *
     * @return array|string
     */
    public function __call($name, $params)
    {
        if (0 === strpos($name, 'get')) {
            $virtualColumn = substr($name, 3);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }

            $virtualColumn = lcfirst($virtualColumn);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }
        }

        if (0 === strpos($name, 'from')) {
            $format = substr($name, 4);

            return $this->importFrom($format, reset($params));
        }

        if (0 === strpos($name, 'to')) {
            $format = substr($name, 2);
            $includeLazyLoadColumns = isset($params[0]) ? $params[0] : true;

            return $this->exportTo($format, $includeLazyLoadColumns);
        }

        throw new BadMethodCallException(sprintf('Call to undefined method: %s.', $name));
    }

}
